/*
 File: fsm_class_phrase_thsym.cpp
 Date and Time: Fri Jan 30 18:55:12 2015 
*/
#include "fsm_class_phrase_th.h"
using namespace NS_yacco2_T_enum;// enumerate
using namespace NS_yacco2_err_symbols;// error symbols
using namespace NS_yacco2_k_symbols;// lrk 
using namespace NS_yacco2_terminals;// terminals
using namespace NS_yacco2_characters;// rc 
using namespace yacco2;// yacco2 library
using namespace NS_fsm_class_phrase_th;// grammar's ns
// first set terminals
yacco2::THR _YACCO2_CALL_TYPE
NS_fsm_class_phrase_th::TH_fsm_class_phrase_th(yacco2::Parser* Caller_pp){
  yacco2::Thread_entry& pp_thread_entry = ITH_fsm_class_phrase_th;
  NS_fsm_class_phrase_th::Cfsm_class_phrase_th Cfsm_class_phrase_th_;// parallel-parser's parse table
#define ssPARSE_TABLE Cfsm_class_phrase_th_
#include "wpp_core.h"
}
THR_result _YACCO2_CALL_TYPE
NS_fsm_class_phrase_th::PROC_TH_fsm_class_phrase_th(yacco2::Parser* Caller_pp){
  char called_proc_name[] = "PROC_TH_fsm_class_phrase_th";
  static bool one_time(false);
  static NS_fsm_class_phrase_th::Cfsm_class_phrase_th* NS_fsm_class_phrase_th_Cfsm_class_phrase_th_(0);// parallel-parser's fsm table
  static Parser* NS_fsm_class_phrase_th_Cfsm_class_phrase_th_parser(0);
  Parser* proc_parser(0);
  if(one_time == false){
    one_time = true;
    NS_fsm_class_phrase_th_Cfsm_class_phrase_th_ = new NS_fsm_class_phrase_th::Cfsm_class_phrase_th();// parallel-parser's fsm table
    NS_fsm_class_phrase_th_Cfsm_class_phrase_th_parser = new Parser(*NS_fsm_class_phrase_th_Cfsm_class_phrase_th_,Caller_pp);
  }
 proc_parser = NS_fsm_class_phrase_th_Cfsm_class_phrase_th_parser;
#include "wproc_pp_core.h"
}
void 
Cfsm_class_phrase_th::reduce_rhs_of_rule
    (yacco2::UINT Sub_rule_no,yacco2::Rule_s_reuse_entry** Recycled_rule){
   int reducing_rule = rhs_to_rules_mapping_[Sub_rule_no];
   Per_rule_s_reuse_table* rule_reuse_tbl_ptr = 
        fsm_rules_reuse_table.per_rule_s_table_[reducing_rule];
   Rule_s_reuse_entry* re(0);
   find_a_recycled_rule(rule_reuse_tbl_ptr,&re);
   (*Recycled_rule) = re;
   fnd_re: switch (Sub_rule_no){
    case rhs1_Rfsm_class_phrase_th_:{
       Rfsm_class_phrase_th* sym;
     if(re->rule_ == 0){
       sym = new Rfsm_class_phrase_th(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rfsm_class_phrase_th*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 3;
    

     sym->sr1();
     return;}
    case rhs1_Rid_:{
       Rid* sym;
     if(re->rule_ == 0){
       sym = new Rid(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rid*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     sym->sr1();
     return;}
    case rhs2_Rid_:{
       Rid* sym;
     if(re->rule_ == 0){
       sym = new Rid(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rid*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     sym->sr2();
     return;}
    case rhs3_Rid_:{
       Rid* sym;
     if(re->rule_ == 0){
       sym = new Rid(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rid*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 1;
    

     sym->sr3();
     return;}
    case rhs1_Rpotential_code_blk_:{
       Rpotential_code_blk* sym;
     if(re->rule_ == 0){
       sym = new Rpotential_code_blk(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rpotential_code_blk*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 1;
    

     return;}
    case rhs1_Rpotential_directives_:{
       Rpotential_directives* sym;
     if(re->rule_ == 0){
       sym = new Rpotential_directives(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rpotential_directives*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 1;
    

     return;}
    case rhs2_Rpotential_directives_:{
       Rpotential_directives* sym;
     if(re->rule_ == 0){
       sym = new Rpotential_directives(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rpotential_directives*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 6;
    

     return;}
    case rhs1_Rmust_directive_phrase_:{
       Rmust_directive_phrase* sym;
     if(re->rule_ == 0){
       sym = new Rmust_directive_phrase(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rmust_directive_phrase*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 5;
    

     sym->sr1();
     return;}
    case rhs1_Rmust_directive_:{
       Rmust_directive* sym;
     if(re->rule_ == 0){
       sym = new Rmust_directive(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rmust_directive*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     sym->sr1();
     sym->op();
     return;}
    case rhs2_Rmust_directive_:{
       Rmust_directive* sym;
     if(re->rule_ == 0){
       sym = new Rmust_directive(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rmust_directive*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     sym->sr2();
     sym->op();
     return;}
    case rhs3_Rmust_directive_:{
       Rmust_directive* sym;
     if(re->rule_ == 0){
       sym = new Rmust_directive(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rmust_directive*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     sym->sr3();
     sym->op();
     return;}
    case rhs4_Rmust_directive_:{
       Rmust_directive* sym;
     if(re->rule_ == 0){
       sym = new Rmust_directive(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rmust_directive*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     sym->sr4();
     sym->op();
     return;}
    case rhs5_Rmust_directive_:{
       Rmust_directive* sym;
     if(re->rule_ == 0){
       sym = new Rmust_directive(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rmust_directive*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     sym->sr5();
     sym->op();
     return;}
    case rhs6_Rmust_directive_:{
       Rmust_directive* sym;
     if(re->rule_ == 0){
       sym = new Rmust_directive(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rmust_directive*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     sym->sr6();
     sym->op();
     return;}
    case rhs7_Rmust_directive_:{
       Rmust_directive* sym;
     if(re->rule_ == 0){
       sym = new Rmust_directive(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rmust_directive*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     sym->sr7();
     sym->op();
     return;}
    case rhs8_Rmust_directive_:{
       Rmust_directive* sym;
     if(re->rule_ == 0){
       sym = new Rmust_directive(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rmust_directive*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     sym->sr8();
     sym->op();
     return;}
    case rhs9_Rmust_directive_:{
       Rmust_directive* sym;
     if(re->rule_ == 0){
       sym = new Rmust_directive(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rmust_directive*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     sym->sr9();
     sym->op();
     return;}
    case rhs10_Rmust_directive_:{
       Rmust_directive* sym;
     if(re->rule_ == 0){
       sym = new Rmust_directive(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rmust_directive*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     sym->sr10();
     sym->op();
     return;}
    case rhs11_Rmust_directive_:{
       Rmust_directive* sym;
     if(re->rule_ == 0){
       sym = new Rmust_directive(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rmust_directive*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     sym->sr11();
     sym->op();
     return;}
    case rhs12_Rmust_directive_:{
       Rmust_directive* sym;
     if(re->rule_ == 0){
       sym = new Rmust_directive(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rmust_directive*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 1;
    

     sym->sr12();
     sym->op();
     return;}
    case rhs1_Rmaybe_more_directives_:{
       Rmaybe_more_directives* sym;
     if(re->rule_ == 0){
       sym = new Rmaybe_more_directives(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rmaybe_more_directives*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 0;
    

     return;}
    case rhs2_Rmaybe_more_directives_:{
       Rmaybe_more_directives* sym;
     if(re->rule_ == 0){
       sym = new Rmaybe_more_directives(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rmaybe_more_directives*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 1;
    

     return;}
    case rhs1_Rmaybe_directive_phrases_:{
       Rmaybe_directive_phrases* sym;
     if(re->rule_ == 0){
       sym = new Rmaybe_directive_phrases(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rmaybe_directive_phrases*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 1;
    

     return;}
    case rhs2_Rmaybe_directive_phrases_:{
       Rmaybe_directive_phrases* sym;
     if(re->rule_ == 0){
       sym = new Rmaybe_directive_phrases(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rmaybe_directive_phrases*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     return;}
    case rhs1_Rmaybe_directive_phrase_:{
       Rmaybe_directive_phrase* sym;
     if(re->rule_ == 0){
       sym = new Rmaybe_directive_phrase(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rmaybe_directive_phrase*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 5;
    

     sym->sr1();
     return;}
    case rhs2_Rmaybe_directive_phrase_:{
       Rmaybe_directive_phrase* sym;
     if(re->rule_ == 0){
       sym = new Rmaybe_directive_phrase(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rmaybe_directive_phrase*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 3;
    

     sym->sr2();
     return;}
    case rhs1_Rdirective_:{
       Rdirective* sym;
     if(re->rule_ == 0){
       sym = new Rdirective(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rdirective*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     sym->sr1();
     sym->op();
     return;}
    case rhs2_Rdirective_:{
       Rdirective* sym;
     if(re->rule_ == 0){
       sym = new Rdirective(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rdirective*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     sym->sr2();
     sym->op();
     return;}
    case rhs3_Rdirective_:{
       Rdirective* sym;
     if(re->rule_ == 0){
       sym = new Rdirective(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rdirective*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     sym->sr3();
     sym->op();
     return;}
    case rhs4_Rdirective_:{
       Rdirective* sym;
     if(re->rule_ == 0){
       sym = new Rdirective(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rdirective*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     sym->sr4();
     sym->op();
     return;}
    case rhs5_Rdirective_:{
       Rdirective* sym;
     if(re->rule_ == 0){
       sym = new Rdirective(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rdirective*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     sym->sr5();
     sym->op();
     return;}
    case rhs6_Rdirective_:{
       Rdirective* sym;
     if(re->rule_ == 0){
       sym = new Rdirective(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rdirective*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     sym->sr6();
     sym->op();
     return;}
    case rhs7_Rdirective_:{
       Rdirective* sym;
     if(re->rule_ == 0){
       sym = new Rdirective(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rdirective*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     sym->sr7();
     sym->op();
     return;}
    case rhs8_Rdirective_:{
       Rdirective* sym;
     if(re->rule_ == 0){
       sym = new Rdirective(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rdirective*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     sym->sr8();
     sym->op();
     return;}
    case rhs9_Rdirective_:{
       Rdirective* sym;
     if(re->rule_ == 0){
       sym = new Rdirective(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rdirective*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     sym->sr9();
     sym->op();
     return;}
    case rhs10_Rdirective_:{
       Rdirective* sym;
     if(re->rule_ == 0){
       sym = new Rdirective(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rdirective*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     sym->sr10();
     sym->op();
     return;}
    case rhs11_Rdirective_:{
       Rdirective* sym;
     if(re->rule_ == 0){
       sym = new Rdirective(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rdirective*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     sym->sr11();
     sym->op();
     return;}
    case rhs1_Rclosing_brace_:{
       Rclosing_brace* sym;
     if(re->rule_ == 0){
       sym = new Rclosing_brace(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rclosing_brace*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 1;
    

     sym->sr1();
     return;}
    case rhs2_Rclosing_brace_:{
       Rclosing_brace* sym;
     if(re->rule_ == 0){
       sym = new Rclosing_brace(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rclosing_brace*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 1;
    

     return;}
    case rhs1_Rsyntax_code_:{
       Rsyntax_code* sym;
     if(re->rule_ == 0){
       sym = new Rsyntax_code(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rsyntax_code*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     sym->sr1();
     return;}
    case rhs2_Rsyntax_code_:{
       Rsyntax_code* sym;
     if(re->rule_ == 0){
       sym = new Rsyntax_code(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rsyntax_code*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     sym->sr2();
     return;}
    case rhs1_Rlint_:{
       Rlint* sym;
     if(re->rule_ == 0){
       sym = new Rlint(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rlint*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     return;}
    case rhs2_Rlint_:{
       Rlint* sym;
     if(re->rule_ == 0){
       sym = new Rlint(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rlint*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 0;
    

     return;}
    case rhs1_Rdirective_cweb_k_:{
       Rdirective_cweb_k* sym;
     if(re->rule_ == 0){
       sym = new Rdirective_cweb_k(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rdirective_cweb_k*)re->rule_;
     }
    sym->ctor();

     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 0;
    

     return;}
    case rhs2_Rdirective_cweb_k_:{
       Rdirective_cweb_k* sym;
     if(re->rule_ == 0){
       sym = new Rdirective_cweb_k(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rdirective_cweb_k*)re->rule_;
     }
    sym->ctor();

     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     sym->sr2();
     return;}
    case rhs3_Rdirective_cweb_k_:{
       Rdirective_cweb_k* sym;
     if(re->rule_ == 0){
       sym = new Rdirective_cweb_k(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rdirective_cweb_k*)re->rule_;
     }
    sym->ctor();

     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     sym->sr3();
     return;}
    case rhs1_Rcweb_k_:{
       Rcweb_k* sym;
     if(re->rule_ == 0){
       sym = new Rcweb_k(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rcweb_k*)re->rule_;
     }
    sym->ctor();

     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     sym->sr1();
     return;}
    case rhs2_Rcweb_k_:{
       Rcweb_k* sym;
     if(re->rule_ == 0){
       sym = new Rcweb_k(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rcweb_k*)re->rule_;
     }
    sym->ctor();

     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     sym->sr2();
     return;}
    default: return;
   }
}
